/* 
 * Berkeley Lab Checkpoint/Restart (BLCR) for Linux is Copyright (c)
 * 2003, The Regents of the University of California, through Lawrence
 * Berkeley National Laboratory (subject to receipt of any required
 * approvals from the U.S. Dept. of Energy).  All rights reserved.
 *
 * Portions may be copyrighted by others, as may be noted in specific
 * copyright notices within specific files.
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: cr_ksyms.h,v 1.2 2003/11/14 19:55:22 phargrov Exp $
 */

#ifndef _CR_KSYMS_H
#define _CR_KSYMS_H	1

/* "Import" a kernel symbol of the given name.
 * Note that the case is preserved in the preprocessor symbol CR_KSYM_*.
 * Note that a declaration/prototype must be seen before use.
 *
 * Example:
 * #if CR_KSYM_foo
 *    #define my_foo CR_IMPORT_KSYM(foo)
 * #else
 *    #define my_foo foo
 * #endif
 */
#define CR_IMPORT_KSYM(NAME) (*(typeof(&NAME))CR_KSYM_##NAME)

#endif
