%define distname blcr-0.2.0
%define modulepkg blcr-modules_2.4.20_20.9pcp1
# disable RedHat's automatic build of a debuginfo subpackage:
%define debug_package %{nil}

Name: blcr
Summary: Berkeley Lab Checkpoint/Restart for Linux
Group: System Environment
Version: 0.2.0
Release: 4
Copyright: GPL
Source: %{distname}.tar.gz
BuildRoot: /tmp/buildroot-%{name}-%{version}
BuildRequires: perl
Prereq: chkconfig /sbin/service
ExclusiveArch: i386
ExclusiveOs: Linux
Requires: %{name}-modules >= %{version}-%{release}

# DON'T require since many clusters are built w/ non-RPM kernels:
# BuildPreReq: kernel-source = 2.4.20-20.9pcp1

%description
Berkeley Lab Checkpoint/Restart for Linux (BLCR)

This package implements system-level checkpointing of scientific applications
in a manner suitable for implementing preemption, migration and fault recovery
by a batch scheduler.

BLCR includes documented interfaces for a cooperating applications or
libraries to implement extensions to the checkpoint system, such as
consistent checkpointing of distributed MPI applications.
Using this package with an appropriate MPI implementation, the vast majority
of scientific applications which use MPI for communucation on Linux clusters
are checkpointable without any modifications to the application source code.

You must also install the blcr-libs package.
%prep
%setup -n %{distname}
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT

%build
%configure '--prefix=/usr/local/blcr-0.2.0'
make

%clean
rm -rf ${RPM_BUILD_ROOT}

%install
make install DESTDIR=${RPM_BUILD_ROOT}
find ${RPM_BUILD_ROOT}/%{_mandir} -name '*.[1-9]' | xargs gzip -9

%post
if [ $1 = 1 ]; then
  /sbin/chkconfig --add blcr
fi
exit 0

%preun
if [ $1 = 0 ]; then
 /sbin/service blcr stop >& /dev/null
 /sbin/chkconfig --del blcr
fi
exit 0

%files
%defattr(-,root,root)
%doc LICENSE.txt
%doc COPYING
%doc COPYING.LIB
%doc README.cvs
%doc %{_mandir}/man1/cr_checkpoint.1.gz
%doc %{_mandir}/man1/cr_restart.1.gz
%doc %{_mandir}/man1/cr_run.1.gz
%{_bindir}/cr_checkpoint
%{_bindir}/cr_info
%{_bindir}/cr_restart
%{_bindir}/cr_run
%dir %{_libdir}/blcr
%{_libexecdir}/vmadcheck
%config %{_sysconfdir}/rc.d/init.d/%{name}

#
# Libs in a separate package
#
%package libs
Group: System Environment/Libraries
Summary: Libraries for Berkeley Lab Checkpoint/Restart for Linux
Copyright: LGPL
Prereq: ldconfig

%description libs
Runtime libaries for Berkeley Lab Checkpoint/Restart for Linux (BLCR)

%post libs
/sbin/ldconfig
exit 0

%postun libs
/sbin/ldconfig
exit 0

%files libs
%{_libdir}/libcr.so.0
%{_libdir}/libcr.so.0.1.0

#
# Separate -devel package
#
%package devel
Requires: %{name}-libs = %{version}-%{release}
Group: Development/Libraries
Summary: Header and object files for Berkeley Lab Checkpoint/Restart for Linux
Copyright: LGPL

%description devel
Header and object files for Berkeley Lab Checkpoint/Restart for Linux
You must also install the blcr-libs package.

%files devel
%{_includedir}/cr.h
%{_includedir}/cr_errcodes.h
%{_includedir}/cr_ioctl.h
%{_includedir}/cr_proc.h
%{_includedir}/libcr.h
%{_libdir}/libcr.la
%{_libdir}/libcr.so

#
# Kernel modules as a separate package
#
%package -n %{modulepkg}
Group: System Environment
Summary: Kernel modules for Berkeley Lab Checkpoint/Restart for Linux
Provides: %{name}-modules = %{version}-%{release}
Prereq: %{name} = %{version}
# DON'T require since many clusters are built w/ non-RPM kernels:
# Requires: kernel = 2.4.20-20.9pcp1

%description -n %{modulepkg}
Kernel modules for Berkeley Lab Checkpoint/Restart for Linux (BLCR)
These kernel modules are built for Linux 2.4.20-20.9pcp1.

%post -n %{modulepkg}
/sbin/service blcr reload >& /dev/null
exit 0

%files -n %{modulepkg}
%defattr(-,root,root)
%dir %{_libdir}/blcr/2.4.20-20.9pcp1
%{_libdir}/blcr/2.4.20-20.9pcp1/cr.o
%{_libdir}/blcr/2.4.20-20.9pcp1/vmadump.o
